<?php
/**
 * Multiblog AI
 *
 * Plugin Name: Multiblog AI
 * Plugin URI:  https://multiblogai.com
 * Description: Multiblog AI
 * Version:     1.0.2
 * Author:      multiblogai.com
 * Author URI:  https://multiblogai.com
 * License:     GPLv2 or later
 * License URI: http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 * Requires at least: 4.9
 * Requires PHP: 5.2.4
 */

if ( ! defined( 'ABSPATH' ) ) {
	die( 'Invalid request.' );
}



if ( ! function_exists( 'mbai_fs' ) ) {
    // Create a helper function for easy SDK access.
    function mbai_fs() {
        global $mbai_fs;

        if ( ! isset( $mbai_fs ) ) {
            // Include Freemius SDK.
            require_once dirname(__FILE__) . '/freemius/start.php';

            $mbai_fs = fs_dynamic_init( array(
                'id'                  => '16105',
                'slug'                => 'multiblog-ai',
                'type'                => 'plugin',
                'public_key'          => 'pk_5c12a2f8e865767cd2c24da5c61c3',
                'is_premium'          => true,
                'is_premium_only'     => true,
                'has_addons'          => false,
                'has_paid_plans'      => true,
                'is_org_compliant'    => false,
                'trial'               => array(
                    'days'               => 3,
                    'is_require_payment' => true,
                ),
                'menu'                => array(
                    'slug'           => 'multiblog-ai',
                    'support'        => false,
                ),
            ) );
        }

        return $mbai_fs;
    }

    // Init Freemius.
    mbai_fs();
    // Signal that SDK was initiated.
    do_action( 'mbai_fs_loaded' );
}



if ( mbai_fs()->is_plan('ro') ) {
    $limit = 100;
} elseif ( mbai_fs()->is_plan('lite') ) {
  $limit = 350;
} else {
  $limit = 40;
}
update_option('mbai_limit', $limit, false);

$posts_translator_timers = [0, 1, 5, 10, 15];
$posts_translator_actions = ['Translate', 'Rewrite'];

$posts_translator_languages = [
                              'Afrikaans',
                              'Aymara',
                              'Bislama',
                              'Bengali',
                              'Chichewa',
                              'Haitian',
                              'Mauritian',
                              'Seychellois',
                              'Trinidadian',
                              'Dhivehi',
                              'Dutch',
                              'American English',
                              'British English',
                              'Australian English',
                              'Fijian',
                              'French',
                              'Gilbertese',
                              'Georgian',
                              'Guarani',
                              'Hausa',
                              'Hebrew',
                              'Hindi',
                              'Igbo',
                              'Indonesian',
                              'Japanese',
                              'Kinyarwanda',
                              'Korean',
                              'Krio',
                              'Lingala',
                              'Malagasy',
                              'Malay',
                              'Mandarin Chinese',
                              'Marshallese',
                              'Māori',
                              'Mongolian',
                              'Nauruan',
                              'Nepali',
                              'Oshiwambo',
                              'Palauan',
                              'Portuguese',
                              'Quechua',
                              'Samoan',
                              'Sesotho',
                              'Sinhala',
                              'Spanish',
                              'Sranan Tongo',
                              'Swahili',
                              'Tagalog',
                              'Filipino',
                              'Tamil',
                              'Tetum',
                              'Thai',
                              'Tok Pisin',
                              'Tongan',
                              'Tuvaluan',
                              'Tswana',
                              'Ukrainian',
                              'Wolof',
                              'Xhosa',
                              'Yoruba',
                              'Zulu',
                              'Arabic',
                              'Azerbaijani',
                              'Bashkir',
                              'Bihari',
                              'Bosnian',
                              'Bulgarian',
                              'Burmese',
                              'Cambodian',
                              'Cantonese',
                              'Catalan',
                              'Czech',
                              'Danish',
                              'Dari',
                              'Dogri',
                              'Esperanto',
                              'Estonian',
                              'Finnish',
                              'German',
                              'Greek',
                              'Hungarian',
                              'Icelandic',
                              'Ido',
                              'Irish',
                              'Italian',
                              'Kazakh',
                              'Khmer',
                              'Kurdish',
                              'Lithuanian',
                              'Macedonian',
                              'Malayalam',
                              'Maltese',
                              'Mizo',
                              'Moldovan',
                              'Montenegrin',
                              'Nepali',
                              'Norwegian',
                              'Odia',
                              'Pashto',
                              'Persian',
                              'Polish',
                              'Punjabi',
                              'Romanian',
                              'Russian',
                              'Scots',
                              'Serbian',
                              'Shona',
                              'Sindhi',
                              'Slovak',
                              'Slovenian',
                              'Somali',
                              'Sundanese',
                              'Swedish',
                              'Tigrinya',
                              'Turkish',
                              'Turkmen',
                              'Vietnamese',
                              'Welsh',
                              'Yiddish'
                              ];
                              
                              
sort($posts_translator_languages);



require_once('AnthropicAPI.php');

require_once('wp-post-import.php');

global $__mbai_wp_post_import;

function mbai_init()
{
    global $__mbai_wp_post_import;
    add_menu_page('multiblog-ai', 'Multiblog AI', 'activate_plugins', 'multiblog-ai', 'mbai_settings_section');
   // add_submenu_page( 'multiblog-ai', 'Settings', 'Settings', 'manage_options', 'multiblog-ai', 'mbai_settings_section' );
    add_submenu_page( 'multiblog-ai', 'Settings', 'Settings', 'manage_options', 'multiblog-ai', 'mbai_settings_section' );

    add_submenu_page('multiblog-ai', 'Posts Import', 'Posts Import', 'manage_options', 'multiblog-ai-import_settings', array($__mbai_wp_post_import, '__import_settings'), $__mbai_wp_post_import->plugin_url . '/assets/images/menu-icon.png');
}

add_action('admin_menu', 'mbai_init');

register_activation_hook(__FILE__, array($__mbai_wp_post_import, '__activate'));

function mbai_settings_section() {
  
  
  
    ?>
     <div class='wrap'>
          <form method='post' action='options.php'>
          <?php
               /* 'option_group' must match 'option_group' from register_setting call */
               settings_fields( 'multiblog-ai' );
               do_settings_sections( 'multiblog-ai' );
          ?>
               <p class='submit'>
                    <input name='submit' type='submit' id='submit' class='button-primary' value='<?php _e("Save Changes") ?>' />
               </p>
          </form>
     </div>
     <?php
}

add_action('admin_init', 'posts_translator_general_section');
function posts_translator_general_section() {  
    add_settings_section(  
        'posts_translator_section', // Section ID 
        'Multiblog AI Plugin Settings', // Section Title
        'posts_translator_options_callback', // Callback
        'multiblog-ai' // What Page?  This makes the section show up on the General Settings Page
    );
/*    
    add_settings_field( // Option 1
        'posts_translator_apikey', // Option ID
        'API Key', // Label
        'posts_translator_apikey_callback', // !important - This is where the args go!
        'multiblog-ai', // Page it will be displayed (General Settings)
        'posts_translator_section', // Name of our section
        array( // The $args
            'posts_translator_apikey' // Should match Option ID
        )  
    ); 
 */   
    add_settings_field( // Option 2
        'posts_translator_action', // Option ID
        'Action', // Label
        'posts_translator_action_callback', // !important - This is where the args go!
        'multiblog-ai', // Page it will be displayed (General Settings)
        'posts_translator_section', // Name of our section
        array( // The $args
            'posts_translator_action' // Should match Option ID
        )  
    ); 
    
    add_settings_field( // Option 3
        'posts_translator_minutes', // Option ID
        'Minutes', // Label
        'posts_translator_minutes_callback', // !important - This is where the args go!
        'multiblog-ai', // Page it will be displayed (General Settings)
        'posts_translator_section', // Name of our section
        array( // The $args
            'posts_translator_minutes' // Should match Option ID
        )  
    ); 
    
    add_settings_field( // Option 4
        'posts_translator_language', // Option ID
        'Language', // Label
        'posts_translator_language_callback', // !important - This is where the args go!
        'multiblog-ai', // Page it will be displayed (General Settings)
        'posts_translator_section', // Name of our section
        array( // The $args
            'posts_translator_language' // Should match Option ID
        )  
    ); 
    
  //  register_setting('multiblog-ai','posts_translator_apikey', array('default' => ''));
    register_setting('multiblog-ai','posts_translator_minutes', array('default' => 0));
    register_setting('multiblog-ai','posts_translator_language', array('default' => 'American English'));
    register_setting('multiblog-ai','posts_translator_action', array('default' => 'Translate'));
}

function mbai_is_available() {
    $used = get_option('mbai_requests_used', 0);
    $limit = get_option('mbai_limit', 0);
    return ($limit > $used);
}

function posts_translator_options_callback() { // Section Callback

    global $mbai_fs;

    $used = get_option('mbai_requests_used', 0);
    $limit = get_option('mbai_limit', 0);
    $available = $limit - $used;

    echo '<h3>You have '.$available.' available translations in this month.</h3>';  
    
    if ( !mbai_fs()->is_plan('pro') ) {
      echo '<h3>Need more? <a href="'.mbai_fs()->get_upgrade_url().'">Please upgrade</a></h3>';  
    }
    echo '<hr>';
}


function posts_translator_apikey_callback($args) {  // Textbox Callback
    $option = get_option($args[0]);
?>
          <input class="regular-text code" type="text" name="<?=$args[0]?>" id="<?=$args[0]?>" value="<?=$option?>">
          <p class="description" id="<?=$args[0]?>-description">Claude API key</p>
<?php
}


function posts_translator_action_callback($args) {  // Textbox Callback
    $option = get_option($args[0]);
    global $posts_translator_actions;
?>
    <select  id="<?=$args[0]?>" name="<?=$args[0]?>" >
          <?php foreach($posts_translator_actions as $action) : ?>
          <option <?php if($option == $action) echo "selected" ?> value="<?=$action?>"><?=$action?></option>
      <?php endforeach; ?>
          </select>
          <p class="description" id="<?=$args[0]?>-description">Select action for AI processor</p>
<?php
}


function posts_translator_minutes_callback($args) {  // Textbox Callback
    $option = get_option($args[0]);
    global $posts_translator_timers;
?>
    <select  id="<?=$args[0]?>" name="<?=$args[0]?>" >
          <?php foreach($posts_translator_timers as $timer) : ?>
          <option <?php if($option == $timer) echo "selected" ?> value="<?=$timer?>"><?=$timer?></option>
      <?php endforeach; ?>
          </select>
          <p class="description" id="<?=$args[0]?>-description">How many minutes you want to delay before processing new posts? <strong>(0 - disabled)</strong></p>
<?php
}


function posts_translator_language_callback($args) {  // Textbox Callback
    $option = get_option($args[0]);
    global $posts_translator_languages;
?>
    <select  id="<?=$args[0]?>" name="<?=$args[0]?>" >
      <?php foreach($posts_translator_languages as $language) : ?>
          <option <?php if($option == $language) echo "selected" ?> value="<?=$language?>"><?=$language?></option>
      <?php endforeach; ?>
          </select>
          <p class="description" id="<?=$args[0]?>-description">What language AI should use for translations</p>
<?php
}




function posts_translator_posts_handler() 
{
	
	if (!mbai_is_available()) return;
	
  	$posts = get_posts(array(
      'numberposts'   => -1,
      'post_type'     => 'post',
      'meta_key'      => 'posts_translator_handled',
      'meta_value'    => 'new'
  ));

	$language = get_option('posts_translator_language');
	$action = get_option('posts_translator_action');
	//$api_key = get_option('posts_translator_apikey');
	
	$api_key = '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';
	
  $anthropic_version = "2023-06-01";
  
  $anthropic_api = new Alle_AI\Anthropic\AnthropicAPI($api_key, $anthropic_version);

	


  if (count($posts)) {
    
    foreach ($posts as $post) {
    
      switch ($action) {
        case 'Rewrite': 
            $messages1 = [
              ['role' => 'user', 'content' => 'Please rewrite the following text:' . $post->post_content],
              ['role' => 'assistant', 'content' => 'The new text is:'],
            ]; 
            $messages2 = [
              ['role' => 'user', 'content' => 'Please rewrite the following text:' . $post->post_title],
              ['role' => 'assistant', 'content' => 'The new text is:'],
            ];
            $user_message_incorrect = 'Please rewrite the following text:' . $post->post_content;
            $assistant_message_incorrect = 'The new text is:';
            $system = 'You are a highly skilled writer with expertise in many areas. Your task is to identify the language of the text  I provide and accurately rewrite the text with approaximely same length but using other words while preserving the meaning, tone, and nuance of the original text. Please maintain proper grammar, spelling and punctuation in the rewrited version.';
            $temperature = 0.8;
            break;
        default: 
            $messages1 = [
              ['role' => 'user', 'content' => 'I want you to translate a text with some HTML elements. It\'s very important to save HTML. Please translate the following text to '.$language.': ' . $post->post_content],
              ['role' => 'assistant', 'content' => 'The translation is:'],
           //   ['role' => 'user', 'content' => 'If response will be too large for output please split output to several messages and continue output in the next message. '],
          //    ['role' => 'assistant', 'content' => 'Next part:'],
            ];
 
            $messages2 = [
              ['role' => 'user', 'content' => 'Translate the following text to '.$language.':' . $post->post_title],
              ['role' => 'assistant', 'content' => 'The translation is:'],
            ];
            $user_message_incorrect = 'I want you to translate a text with some HTML elements. It\'s very important to save HTML. Please translate the following text to '.$language.': ' . $post->post_content;
            $assistant_message_incorrect = 'The translation is:';
            $system = 'You are a highly skilled HTML developer and translator with expertise in many languages. Your task is to identify the language of the text of HTML document I provide and accurately translate text into the specified target language while preserving the meaning, tone, html tags, and nuance of the original text. Please maintain proper grammar, spelling, punctuation and leave HTML tags on their places in the translated version.';
            $temperature = 0.0;
            break;
      }
    
      $data = array(
          'model' => 'claude-3-haiku-20240307',
          'temperature' => $temperature,
          'max_tokens' => 4096,
          'system' => $system,
          'messages' => $messages1
        );
      $response = $anthropic_api->generateText($data);
 
      $new_post_content = '';
      if (isset($response['content'])) {
        foreach ($response['content'] as $part) {
          $new_post_content .= $part['text'];
        }
      }
 
      if (isset($response['stop_reason']) && $response['stop_reason'] != 'max_tokens' && $response['usage']['input_tokens'] - $response['usage']['output_tokens'] > 1000) {
        

        
        $messages_incorrect = [
              ['role' => 'user', 'content' => $user_message_incorrect],
              ['role' => 'assistant', 'content' => $assistant_message_incorrect . $new_post_content],
              ['role' => 'user', 'content' => 'The text is incorrect. I asked you to accurately '.strtolower($action).' the text. Please try again.'],
              ['role' => 'assistant', 'content' => 'Ok. '. $assistant_message_incorrect ]
          ];
        
        $data = array(
            'model' => 'claude-3-haiku-20240307',
            'temperature' => $temperature,
            'max_tokens' => 4096,
            'system' => $system,
            'messages' => $messages_incorrect
          );
        $response = $anthropic_api->generateText($data);
        
        $new_post_content = '';
        if (isset($response['content'])) {
          foreach ($response['content'] as $part) {
            $new_post_content .= $part['text'];
          }
        }
        

      }
      
      if (isset($response['stop_reason']) && $response['stop_reason'] == 'max_tokens') {
        $i = 0;

     $new_post_content = trim($new_post_content);
     $last_space = strrpos($new_post_content, ' ');
     
       $new_post_content = substr($new_post_content, 0, $last_space);
     
          $data = array(
              'model' => 'claude-3-haiku-20240307',
              'temperature' => $temperature,
              'max_tokens' => 4096,
              'system' => $system,
              'messages' => [
                      ['role' => 'user', 'content' => $user_message_incorrect],
                      ['role' => 'assistant', 'content' => $assistant_message_incorrect . $new_post_content],
                      ['role' => 'user', 'content' => 'please continue'],
                      ['role' => 'assistant', 'content' => 'Next part:' ],
              ]
            );
          $response = $anthropic_api->generateText($data);
          
          if (isset($response['content'])) {
            foreach ($response['content'] as $part) {
              $new_post_content .= $part['text'];
            }
          }


      }
  		
  		$post->post_content = $new_post_content;
  		
  		
    
      $data = array(
          'model' => 'claude-3-haiku-20240307',
          'temperature' => $temperature,
          'max_tokens' => 700,
          'system' => $system,
          'messages' => $messages2
        );
      $response = $anthropic_api->generateText($data);

      
      $new_post_title = '';
      if (isset($response['content'])) {
        foreach ($response['content'] as $part) {
          $new_post_title .= $part['text'];
        }
      }
  		
  		$post->post_title = $new_post_title;
  		
  
  		wp_update_post( $post );
  		
  		$used_requests = get_option('mbai_requests_used', 0);
  		
  		
      update_option('mbai_requests_used', ++$used_requests, false);
  		update_post_meta( $post->ID, 'posts_translator_handled', 'processed');
  	}
    
    
    
    
  }
	
	

}

function posts_translator_save_post( $post_id ) 
{
    if (get_post_status( $post_id ) !== 'publish' || get_post_type($post_id) != 'post') return; 
    
    
    $isHandled = get_post_meta( $post_id, 'posts_translator_handled', true );
    
    if ($isHandled) return;
    update_post_meta( $post_id, 'posts_translator_handled', 'new');
    
}
add_action( 'save_post', 'posts_translator_save_post' );

function posts_translator_monthly_reset() {
  update_option('mbai_requests_used', 0, false);
}


// Cron jobs

add_filter( 'cron_schedules', 'posts_translator_cron_five' );
function posts_translator_cron_five( $schedules ) {
	$schedules['posts_translator_5'] = array(
		'interval' => 60 * 5,
		'display' => 'posts_translator_five'
	);
	return $schedules;
}

add_filter( 'cron_schedules', 'posts_translator_cron_one' );
function posts_translator_cron_one( $schedules ) {
	$schedules['posts_translator_1'] = array(
		'interval' => 60 * 1,
		'display' => 'posts_translator_one'
	);
	return $schedules;
}

add_filter( 'cron_schedules', 'posts_translator_cron_ten' );
function posts_translator_cron_ten( $schedules ) {
	$schedules['posts_translator_10'] = array(
		'interval' => 60 * 10,
		'display' => 'posts_translator_ten'
	);
	return $schedules;
}

add_filter( 'cron_schedules', 'posts_translator_cron_fifteen' );
function posts_translator_cron_fifteen( $schedules ) {
	$schedules['posts_translator_15'] = array(
		'interval' => 60 * 15,
		'display' => 'posts_translator_fifteen'
	);
	return $schedules;
}


add_filter( 'cron_schedules', 'posts_translator_cron_month' );
function posts_translator_cron_month( $schedules ) {
	$schedules['posts_translator_month'] = array(
		'interval' => 60 * 60 * 24 *30,
		'display' => 'posts_translator_month'
	);
	return $schedules;
}


add_action( 'plugins_loaded', 'posts_translator_init_cron' );
add_action( 'posts_translator_start_cron', 'posts_translator_posts_handler' );
add_action( 'posts_translator_start_monthly_cron', 'posts_translator_monthly_reset' );


function posts_translator_init_cron()
{
	if( ! wp_next_scheduled( 'posts_translator_start_monthly_cron' ) ) {
		wp_schedule_event( time(), 'posts_translator_month', 'posts_translator_start_monthly_cron');
	} 
  
	$minutes = get_option('posts_translator_minutes');
	
	if (!$minutes) {
	  wp_clear_scheduled_hook( 'posts_translator_start_cron' );
	  return;
	}
  
	if( ! wp_next_scheduled( 'posts_translator_start_cron' ) ) {
		wp_schedule_event( time(), 'posts_translator_' . $minutes, 'posts_translator_start_cron');
	} else if (wp_get_schedule( 'posts_translator_start_cron' ) != 'posts_translator_' . $minutes) {
		wp_clear_scheduled_hook( 'posts_translator_start_cron' );
		wp_schedule_event( time(), 'posts_translator_' . $minutes, 'posts_translator_start_cron');
	}
}